/*--------------------------------------------------------------------
 |		Copyright 1998 ( ralao@venus.org ) 
 +--------------------------------------------------------------------
 |
 |      WDM CSA+ Network header file 
 |      by ralao ( ENST 1998 )
 |
 |		This file may be copied, modified and freely distributed as
 |		long as this notice is provided.
 |
 |		Disclaimer :
 |      ------------
 |			This file is part of a Network simulator program. It is 
 |		provided AS IS. Though it has been tested and found harmless 
 |		for any computer, venus.org may not be held liable for any 
 |		damage resulting in the usage of this file.
 |
 +---------------------------------------------------------------------
 |		For assistance, you may contact ralao@venus.org
 +--------------------------------------------------------------------*/



#ifndef _WDM_CSA_P_NETWORK_H_
#define _WDM_CSA_P_NETWORK_H_


/*--------------------------------------------------------------------
 |	Include definitions bellow this line
 +--------------------------------------------------------------------*/
#include "wdm_network.h"

/*--------------------------------------------------------------------
 |  Type definitions bellow this line
 +--------------------------------------------------------------------*/

 
 /*--------------------------------------------------------------------
 |  Class definitions bellow this line
 +--------------------------------------------------------------------*/
class CWDM_CSA_P_Network : public CWDM_Network
{

public :
    
    /* overloaded public constructor */
    CWDM_CSA_P_Network( long N_station, long k_network, double  p_arr );

    /* public virtual destructor */
    /*  must be redifined in derived classes */
    ~CWDM_CSA_P_Network( void );

    /* simulates the activity of the network for a simu_length slot period */
    /*  must be redifined in derived classes */
    void simulate( long simu_length );

};   /* end of CWDM_CSA_P_Network class */

#endif  // _WDM_CSA_P_Network_H_