/*--------------------------------------------------------------------
 |		Copyright 1998 ( ralao@venus.org ) 
 +--------------------------------------------------------------------
 |
 |      WDM CSA Station source file 
 |      by ralao ( ENST 1998 )
 |
 |		This file may be copied, modified and freely distributed as
 |		long as this notice is provided.
 |
 |		Disclaimer :
 |      ------------
 |			This file is part of a Network simulator program. It is 
 |		provided AS IS. Though it has been tested and found harmless 
 |		for any computer, venus.org may not be held liable for any 
 |		damage resulting in the usage of this file.
 |
 +---------------------------------------------------------------------
 |		For assistance, you may contact ralao@venus.org
 +--------------------------------------------------------------------*/


/*--------------------------------------------------------------------
 |	Include definitions bellow this line
 +--------------------------------------------------------------------*/
#include "wdm_csa_station.h"
#include "assert.h"


/*--------------------------------------------------------------------
 |	Function bodies bellow this line
 +--------------------------------------------------------------------*/

/*--------------------------------------------------------------------
 |	CWDM_Station : public constructor
 +--------------------------------------------------------------------*/
CWDM_CSA_Station::CWDM_CSA_Station( long station_id, long N_station, long k_net, double p_arr ) :
    CWDM_Station( station_id, N_station, k_net, p_arr )
{
}


 /*--------------------------------------------------------------------
 |	~CWDM_CSA_Station : public virtual destructor
 +--------------------------------------------------------------------*/
CWDM_CSA_Station::~CWDM_CSA_Station( void )
{
    // C++ calls default base class destructor automatically after
}


/*-----------------------------------------------------------------------------
 |	upadte_control_slot :   updates the control minislot of the sation   
 +-----------------------------------------------------------------------------*/
void CWDM_CSA_Station::update_control_slot( char *control_slot )
{
    int i   = 0;
    int msb = this->id * N; // minislot base

    assert( control_slot );
    for( i = 0; i < N; i++ ) {
        control_slot[ msb + i ] = TB[i][0].occupied ? 1 : 0;
    }
}
