/*--------------------------------------------------------------------
 |		Copyright 1998 ( ralao@venus.org ) 
 +--------------------------------------------------------------------
 |
 |      Simu_log_dlg.cpp : implementation file
 |      by ralao ( ENST 1998 )
 |
 |		This file may be copied, modified and freely distributed as
 |		long as this notice is provided.
 |
 |		Disclaimer :
 |      ------------
 |			This file is part of a Network simulator program. It is 
 |		provided AS IS. Though it has been tested and found harmless 
 |		for any computer, venus.org may not be held liable for any 
 |		damage resulting in the usage of this file.
 |
 +---------------------------------------------------------------------
 |		For assistance, you may contact ralao@venus.org
 +--------------------------------------------------------------------*/



// Simu_log_dlg.cpp : implementation file
//

#include "stdafx.h"
#include "wsasim.h"
#include "Simu_log_dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "assert.h"

#define P2T_SIZE	560		// Probe To Text Size : number of bytes needed to display a probe

/////////////////////////////////////////////////////////////////////////////
// CSimu_log_dlg dialog


CSimu_log_dlg::CSimu_log_dlg(CWnd* pParent /*=NULL*/, WDM_Simu_Context *SC /*=NULL*/ )
	: CDialog(CSimu_log_dlg::IDD, pParent)
{
	assert( SC );
    this->SC = SC;
	//{{AFX_DATA_INIT(CSimu_log_dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CSimu_log_dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSimu_log_dlg)
	DDX_Control(pDX, IDC_EDIT1, m_edit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSimu_log_dlg, CDialog)
	//{{AFX_MSG_MAP(CSimu_log_dlg)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSimu_log_dlg message handlers

BOOL CSimu_log_dlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	int		i		= 0;
	int		ai		= 0;    // algo_index
	int		np		= SC->simu_res.n_point;
	int		na		= SC->simu_res.n_algo;
	int		tmp_size;		// just the number of bytes stores in tmp currently 
	char	*tmp	= NULL;	// string tmp

	tmp = ( char * )malloc( P2T_SIZE * na * np * sizeof( char ) );
	assert( tmp );
	tmp_size	=	sprintf( tmp, "" );
    if ( SC->simu_param.rsa ) {         // RSA has been simulated, prints the results
		tmp_size += sprintf( tmp + tmp_size, "\r\n* Simulating RSA network...********************\r\n\r\n");
        for ( i = 0; i < np; i++ ) {
			WDM_Probe	probe = SC->simu_res.res[ai*np + i];
			tmp_size += sprintf( tmp + tmp_size, "  -> Point %d / %d :\r\n", i+1, np);
			tmp_size += sprintf( tmp + tmp_size, "\tnsg = %9ld    nes = %9ld\r\n", probe.nsg, probe.nes);    
			tmp_size += sprintf( tmp + tmp_size, "\tnpg = %9ld    npt = %9ld\r\n", probe.npg, probe.npt);    
			tmp_size += sprintf( tmp + tmp_size, "\tnpb = %9ld    npl = %9ld\r\n", probe.npb, probe.npl);    
			tmp_size += sprintf( tmp + tmp_size, "\tnsr = %9ld    nra = %9ld\r\n", probe.nsr, probe.nra);    
			tmp_size += sprintf( tmp + tmp_size, "\ttsd = %9ld    q   = %9f\r\n", probe.tsd, probe.q);    
			tmp_size += sprintf( tmp + tmp_size, "\tro  = %9f    asd = %9f\r\n", probe.ro, probe.asd);    
			tmp_size += sprintf( tmp + tmp_size, "\tant = %9f    apl = %9f\r\n", probe.ant, probe.apl);    
        }
        ai++;
    }
    if ( SC->simu_param.csa ) {         // CSA has been simulated, draws the results
		tmp_size += sprintf( tmp + tmp_size, "\r\n* Simulating CSA network...********************\r\n\r\n");
        for ( i = 0; i < np; i++ ) {
			WDM_Probe	probe = SC->simu_res.res[ai*np + i];
			tmp_size += sprintf( tmp + tmp_size, "  -> Point %d / %d :\r\n", i+1, np);
			tmp_size += sprintf( tmp + tmp_size, "\tnsg = %9ld    nes = %9ld\r\n", probe.nsg, probe.nes);    
			tmp_size += sprintf( tmp + tmp_size, "\tnpg = %9ld    npt = %9ld\r\n", probe.npg, probe.npt);    
			tmp_size += sprintf( tmp + tmp_size, "\tnpb = %9ld    npl = %9ld\r\n", probe.npb, probe.npl);    
			tmp_size += sprintf( tmp + tmp_size, "\tnsr = %9ld    nra = %9ld\r\n", probe.nsr, probe.nra);    
			tmp_size += sprintf( tmp + tmp_size, "\ttsd = %9ld    q   = %9f\r\n", probe.tsd, probe.q);    
			tmp_size += sprintf( tmp + tmp_size, "\tro  = %9f    asd = %9f\r\n", probe.ro, probe.asd);    
			tmp_size += sprintf( tmp + tmp_size, "\tant = %9f    apl = %9f\r\n", probe.ant, probe.apl);    
        }
        ai++;
    }
    if ( SC->simu_param.csa_p ) {       // CSA+ has been simulated, draws the results
		tmp_size += sprintf( tmp + tmp_size, "\r\n* Simulating CSA+ network...********************\r\n\r\n");
        for ( i = 0; i < np; i++ ) {
			WDM_Probe	probe = SC->simu_res.res[ai*np + i];
			tmp_size += sprintf( tmp + tmp_size, "  -> Point %d / %d :\r\n", i+1, np);
			tmp_size += sprintf( tmp + tmp_size, "\tnsg = %9ld    nes = %9ld\r\n", probe.nsg, probe.nes);    
			tmp_size += sprintf( tmp + tmp_size, "\tnpg = %9ld    npt = %9ld\r\n", probe.npg, probe.npt);    
			tmp_size += sprintf( tmp + tmp_size, "\tnpb = %9ld    npl = %9ld\r\n", probe.npb, probe.npl);    
			tmp_size += sprintf( tmp + tmp_size, "\tnsr = %9ld    nra = %9ld\r\n", probe.nsr, probe.nra);    
			tmp_size += sprintf( tmp + tmp_size, "\ttsd = %9ld    q   = %9f\r\n", probe.tsd, probe.q);    
			tmp_size += sprintf( tmp + tmp_size, "\tro  = %9f    asd = %9f\r\n", probe.ro, probe.asd);    
			tmp_size += sprintf( tmp + tmp_size, "\tant = %9f    apl = %9f\r\n", probe.ant, probe.apl);    
        }
        ai++;
    }
	// sets the text in the control
	m_edit.SetWindowText( tmp );
	free( tmp );
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSimu_log_dlg::OnSave() 
{
	// TODO: Add your control notification handler code here
	int		i		= 0;
	int		ai		= 0;    // algo_index
	int		np		= SC->simu_res.n_point;
	int		na		= SC->simu_res.n_algo;
		
	// ask for the filename
	CFileDialog		*file_dlg = new CFileDialog( FALSE );
	CString			filename;
	FILE			*f = NULL;
	if ( file_dlg->DoModal() != IDOK ) return;
	// creates the new file
	filename	= file_dlg->GetPathName();
	f			= fopen( filename.GetBuffer(0), "wt" );
	assert( f );
	filename.ReleaseBuffer();
	delete file_dlg;
	// writes the results logs in this file
	fprintf( f, "\t+++++++++++++++++++++++++++ Simulation Log +++++++++++++++++++++++++++\r\n\r\n");
	fprintf( f, "\tNumber of Station N = %ld\r\n", SC->net_param.n_station );
	fprintf( f, "\tNetwork Size ( k in slot ) = %ld\r\n", SC->net_param.n_size );
	fprintf( f, "\tNumber of Point Simulated = %ld\r\n", SC->simu_param.npoint );
	fprintf( f, "\tNumber of Slot Simulated per Point = %ld\r\n", SC->simu_param.nslot );
	// writes the results for each algorithm
    if ( SC->simu_param.rsa ) {         // RSA has been simulated, prints the results
		fprintf( f, "\r\n* Simulating RSA network...********************\r\n\r\n");
        for ( i = 0; i < np; i++ ) {
			WDM_Probe	probe = SC->simu_res.res[ai*np + i];
			fprintf( f, "  -> Point %d / %d :\r\n", i+1, np);
			fprintf( f, "\tnsg = %9ld    nes = %9ld\r\n", probe.nsg, probe.nes);    
			fprintf( f, "\tnpg = %9ld    npt = %9ld\r\n", probe.npg, probe.npt);    
			fprintf( f, "\tnpb = %9ld    npl = %9ld\r\n", probe.npb, probe.npl);    
			fprintf( f, "\tnsr = %9ld    nra = %9ld\r\n", probe.nsr, probe.nra);    
			fprintf( f, "\ttsd = %9ld    q   = %9f\r\n", probe.tsd, probe.q);    
			fprintf( f, "\tro  = %9f    asd = %9f\r\n", probe.ro, probe.asd);    
			fprintf( f, "\tant = %9f    apl = %9f\r\n", probe.ant, probe.apl);    
        }
        ai++;
    }
    if ( SC->simu_param.csa ) {         // CSA has been simulated, draws the results
		fprintf( f, "\r\n* Simulating CSA network...********************\r\n\r\n");
        for ( i = 0; i < np; i++ ) {
			WDM_Probe	probe = SC->simu_res.res[ai*np + i];
			fprintf( f, "  -> Point %d / %d :\r\n", i+1, np);
			fprintf( f, "\tnsg = %9ld    nes = %9ld\r\n", probe.nsg, probe.nes);    
			fprintf( f, "\tnpg = %9ld    npt = %9ld\r\n", probe.npg, probe.npt);    
			fprintf( f, "\tnpb = %9ld    npl = %9ld\r\n", probe.npb, probe.npl);    
			fprintf( f, "\tnsr = %9ld    nra = %9ld\r\n", probe.nsr, probe.nra);    
			fprintf( f, "\ttsd = %9ld    q   = %9f\r\n", probe.tsd, probe.q);    
			fprintf( f, "\tro  = %9f    asd = %9f\r\n", probe.ro, probe.asd);    
			fprintf( f, "\tant = %9f    apl = %9f\r\n", probe.ant, probe.apl);    
        }
        ai++;
    }
    if ( SC->simu_param.csa_p ) {       // CSA+ has been simulated, draws the results
		fprintf( f, "\r\n* Simulating CSA+ network...********************\r\n\r\n");
        for ( i = 0; i < np; i++ ) {
			WDM_Probe	probe = SC->simu_res.res[ai*np + i];
			fprintf( f, "  -> Point %d / %d :\r\n", i+1, np);
			fprintf( f, "\tnsg = %9ld    nes = %9ld\r\n", probe.nsg, probe.nes);    
			fprintf( f, "\tnpg = %9ld    npt = %9ld\r\n", probe.npg, probe.npt);    
			fprintf( f, "\tnpb = %9ld    npl = %9ld\r\n", probe.npb, probe.npl);    
			fprintf( f, "\tnsr = %9ld    nra = %9ld\r\n", probe.nsr, probe.nra);    
			fprintf( f, "\ttsd = %9ld    q   = %9f\r\n", probe.tsd, probe.q);    
			fprintf( f, "\tro  = %9f    asd = %9f\r\n", probe.ro, probe.asd);    
			fprintf( f, "\tant = %9f    apl = %9f\r\n", probe.ant, probe.apl);    
        }
        ai++;
    }
	fprintf( f, "\r\n\t+++++++++++++++++++++++++++ End of Log +++++++++++++++++++++++++++\r\n\r\n");
	fclose( f );
}
