/*--------------------------------------------------------------------
 |		Copyright 1998 ( ralao@venus.org ) 
 +--------------------------------------------------------------------
 |
 |      Simu_param_dlg.cpp : implementation file
 |      by ralao ( ENST 1998 )
 |
 |		This file may be copied, modified and freely distributed as
 |		long as this notice is provided.
 |
 |		Disclaimer :
 |      ------------
 |			This file is part of a Network simulator program. It is 
 |		provided AS IS. Though it has been tested and found harmless 
 |		for any computer, venus.org may not be held liable for any 
 |		damage resulting in the usage of this file.
 |
 +---------------------------------------------------------------------
 |		For assistance, you may contact ralao@venus.org
 +--------------------------------------------------------------------*/



// Simu_param_dlg.cpp : implementation file
//

#include "stdafx.h"
#include "wsasim.h"
#include "Simu_param_dlg.h"
#include "assert.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSimu_param_dlg dialog


CSimu_param_dlg::CSimu_param_dlg(CWnd* pParent /*=NULL*/, WDM_Simu_Context *SC)
	: CDialog(CSimu_param_dlg::IDD, pParent)
{
    this->SC = SC;
    assert( this->SC );
    //{{AFX_DATA_INIT(CSimu_param_dlg)
	m_ant = SC->simu_param.ant;
	m_apl = SC->simu_param.apl;
	m_asd = SC->simu_param.asd;
	m_csa = SC->simu_param.csa;
	m_csa_p = SC->simu_param.csa_p;
	m_n_size = SC->net_param.n_size;
	m_n_station = SC->net_param.n_station;;
	m_npoint = SC->simu_param.npoint;
	m_nslot = SC->simu_param.nslot;
	m_rsa = SC->simu_param.rsa;
	m_q = SC->simu_param.q;
	//}}AFX_DATA_INIT
}


void CSimu_param_dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSimu_param_dlg)
	DDX_Check(pDX, IDC_ant, m_ant);
	DDX_Check(pDX, IDC_apl, m_apl);
	DDX_Check(pDX, IDC_asd, m_asd);
	DDX_Check(pDX, IDC_CSA, m_csa);
	DDX_Check(pDX, IDC_CSA_P, m_csa_p);
	DDX_Text(pDX, IDC_N_Size, m_n_size);
	DDV_MinMaxUInt(pDX, m_n_size, 1, 10000);
	DDX_Text(pDX, IDC_N_Station, m_n_station);
	DDV_MinMaxUInt(pDX, m_n_station, 1, 10000);
	DDX_Text(pDX, IDC_Npoint, m_npoint);
	DDV_MinMaxUInt(pDX, m_npoint, 1, 1000);
	DDX_Text(pDX, IDC_Nslot, m_nslot);
	DDV_MinMaxUInt(pDX, m_nslot, 1, 1000000000);
	DDX_Check(pDX, IDC_RSA, m_rsa);
	DDX_Check(pDX, IDC_q, m_q);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSimu_param_dlg, CDialog)
	//{{AFX_MSG_MAP(CSimu_param_dlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSimu_param_dlg message handlers

void CSimu_param_dlg::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData( TRUE );	// retrieves the Data from the dialog box
    // updates 	the simulation context
    SC->simu_param.filled   = TRUE;
	SC->simu_param.rsa      = m_rsa;
	SC->simu_param.csa      = m_csa;
    SC->simu_param.csa_p    = m_csa_p;
	SC->simu_param.ant      = m_ant;
	SC->simu_param.apl      = m_apl;
    SC->simu_param.asd      = m_asd;
    SC->simu_param.q        = m_q;
    SC->simu_param.npoint   = m_npoint;
    SC->simu_param.nslot    = m_nslot;
    SC->net_param.n_station = m_n_station;
    SC->net_param.n_size    = m_n_size;
    SC->simu_state.running  = FALSE;
    SC->simu_state.canceled = FALSE;
    SC->simu_state.done     = FALSE;
    CDialog::OnOK();
}

void CSimu_param_dlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}
